> This page is for Developer.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.bigcommerce.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.bigcommerce.com/_mcp/server.

# Create Customer Metafields

POST https://api.bigcommerce.com/stores/{store_hash}/v3/customers/{customerId}/metafields
Content-Type: application/json

Creates Customer metafields by passing the `customerId` in the query parameters.

Reference: https://docs.bigcommerce.com/developer/api-reference/rest/admin/management/customers/v3/metafields/create-customer-metafields

## Authentication

- `X-Auth-Token` header (required) — ### OAuth scopes | UI Name | Permission | Parameter | |:--------|:-----------|:----------| | Customers | modify | `store_v2_customers` | | Customers | read-only | `store_v2_customers_read_only` | | Stored Payment Instruments | modify | `store_stored_payment_instruments` | | Stored Payment Instruments | read-only | `store_stored_payment_instruments_read_only` | ### Authentication header | Header | Argument | Description | |:-------|:---------|:------------| | `X-Auth-Token` | `access_token` | For more about API accounts that generate `access_token`s, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#api-accounts). | ### Further reading For example requests and more information about authenticating BigCommerce APIs, see [Authentication and Example Requests](/developer/docs/overview/api-fundamentals/api-accounts#x-auth-token-header-example-requests). For more about BigCommerce OAuth scopes, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#oauth-scopes). For a list of API status codes, see [API Status Codes](/developer/api-reference/rest/overview#rest-http-status-codes).

## Request

### Path parameters

- `customerId` (integer, required) — The ID of the customer.
- `store_hash` (string, required) — Permanent ID of the BigCommerce store.

### Body (application/json)

This endpoint expects a MetafieldBase_Post.

- `permission_set` (enum, required) — Determines the visibility and writeability of the field by other API consumers. | Value | Description | | :--- | :--- | | `app_only` | Private to the app that owns the field. | | `read` | Visible to other API consumers. | | `write` | Open for reading and writing by other API consumers. | | `read_and_sf_access` | Visible to other API consumers, including on the storefront. | | `write_and_sf_access` | Open for reading and writing by other API consumers, including on the storefront. |
  - Allowed values: `app_only`, `read`, `write`, `read_and_sf_access`, `write_and_sf_access`
- `namespace` (string, required) — Namespace for the metafield, for organizational purposes.
- `key` (string, required) — The name of the field, for example: `location_id`, `color`.
- `value` (string, required) — The value of the field, for example: `1`, `blue`.
- `description` (string, optional) — Description for the metafields.

## Response

### 200

Response payload for the BigCommerce API.

- `data` (list of Metafield, optional)
- `errors` (list of any, optional) — Empty for 200 responses.
- `meta` (CollectionMeta, optional) — Data about the response, including pagination and collection totals.

## Errors

### 400 Bad Request Error

Bad Request. Input is invalid.

- `status` (double, optional)
- `title` (string, optional)
- `type` (string, optional)
- `detail` (string, optional)

### 409 Conflict Error

The `Metafield` conflicts with another `Metafield`. This can result from duplicate unique key combinations of the appʼs client id, namespace, key, resource_type, and resource_id.

- `status` (integer, optional) — The HTTP status code.
- `title` (string, optional) — The error title describing the particular error.
- `type` (string, optional) — A link to a list of BigCommerce API status codes.
- `instance` (string, optional)
- `errors` (ErrorResponseErrors, optional)

### 422 Unprocessable Entity Error

The `Metafield` was not valid. This is the result of missing required fields, or of invalid data. See the response for more details.

- `status` (integer, optional) — The HTTP status code.
- `title` (string, optional) — The error title describing the particular error.
- `type` (string, optional) — A link to a list of BigCommerce API status codes.
- `instance` (string, optional)
- `errors` (ErrorResponseErrors, optional)

## Types

### Metafield

Common metafield properties.

- `permission_set` (enum, required) — Determines the visibility and writeability of the field by other API consumers. | Value | Description | | :--- | :--- | | `app_only` | Private to the app that owns the field. | | `read` | Visible to other API consumers. | | `write` | Open for reading and writing by other API consumers. | | `read_and_sf_access` | Visible to other API consumers, including on storefront. | | `write_and_sf_access` | Open for reading and writing by other API consumers, including on storefront. |
  - Allowed values: `app_only`, `read`, `write`, `read_and_sf_access`, `write_and_sf_access`
- `namespace` (string, required) — Namespace for the metafield, for organizational purposes.
- `key` (string, required) — The name of the field, for example: `location_id`, `color`.
- `value` (string, required) — The value of the field, for example: `1`, `blue`.
- `description` (string, required) — Description for the metafields.
- `resource_type` (enum, required) — The type of resource with which the metafield is associated.
  - Allowed values: `brand`, `product`, `variant`, `category`, `cart`, `channel`, `location`, `order`, `customer`
- `resource_id` (integer, required) — The unique identifier for the resource with which the metafield is associated.
- `id` (integer, required) — The unique identifier for the metafield.
- `date_created` (datetime, required) — Date and time of the metafieldʼs creation.
- `date_modified` (datetime, required) — Date and time when the metafield was last updated.
- `owner_client_id` (string, optional) — Client ID for the metafieldʼs creator.

### CollectionMeta

Data about the response, including pagination and collection totals.

- `pagination` (CollectionMetaPagination, optional) — Data about the response, including pagination and collection totals.

### ErrorResponseErrors

### CollectionMetaPagination

Data about the response, including pagination and collection totals.

- `total` (integer, optional) — Total number of items in the result set.
- `count` (integer, optional) — Total number of items in the collection response.
- `per_page` (integer, optional) — The amount of items returned in the collection per page, controlled by the limit parameter.
- `current_page` (integer, optional) — The page you are currently on within the collection.
- `total_pages` (integer, optional) — The total number of pages in the collection.
- `links` (CollectionMetaPaginationLinks, optional) — Pagination links for the previous and next parts of the whole collection.

### CollectionMetaPaginationLinks

Pagination links for the previous and next parts of the whole collection.

- `previous` (string, optional) — Link to the previous page returned in the response.
- `current` (string, optional) — Link to the current page returned in the response.
- `next` (string, optional) — Link to the next page returned in the response.

## Examples

**Request**

```json
{
  "permission_set": "app_only",
  "namespace": "Sales Department",
  "key": "Staff Name",
  "value": "Ronaldo"
}
```

**Response**

```json
{
  "data": [
    {
      "permission_set": "app_only",
      "namespace": "Sales Department",
      "key": "Staff Name",
      "value": "Ronaldo",
      "description": "order",
      "resource_type": "cart",
      "resource_id": 424242,
      "id": 1,
      "date_created": "2022-06-16T18:39:00+00:00",
      "date_modified": "2022-06-16T18:39:00+00:00",
      "owner_client_id": "ramciw4fnoz87it3ynjfif2zrkil5p"
    }
  ],
  "errors": [],
  "meta": {
    "pagination": {
      "total": 36,
      "count": 36,
      "per_page": 50,
      "current_page": 1,
      "total_pages": 1,
      "links": {
        "previous": "string",
        "current": "?page=1&limit=50",
        "next": "string"
      }
    }
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.bigcommerce.com/stores/store_hash/v3/customers/1/metafields"

payload = {
    "permission_set": "app_only",
    "namespace": "Sales Department",
    "key": "Staff Name",
    "value": "Ronaldo"
}
headers = {
    "X-Auth-Token": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.bigcommerce.com/stores/store_hash/v3/customers/1/metafields';
const options = {
  method: 'POST',
  headers: {'X-Auth-Token': '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"permission_set":"app_only","namespace":"Sales Department","key":"Staff Name","value":"Ronaldo"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.bigcommerce.com/stores/store_hash/v3/customers/1/metafields"

	payload := strings.NewReader("{\n  \"permission_set\": \"app_only\",\n  \"namespace\": \"Sales Department\",\n  \"key\": \"Staff Name\",\n  \"value\": \"Ronaldo\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("X-Auth-Token", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.bigcommerce.com/stores/store_hash/v3/customers/1/metafields")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["X-Auth-Token"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"permission_set\": \"app_only\",\n  \"namespace\": \"Sales Department\",\n  \"key\": \"Staff Name\",\n  \"value\": \"Ronaldo\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.bigcommerce.com/stores/store_hash/v3/customers/1/metafields")
  .header("X-Auth-Token", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"permission_set\": \"app_only\",\n  \"namespace\": \"Sales Department\",\n  \"key\": \"Staff Name\",\n  \"value\": \"Ronaldo\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.bigcommerce.com/stores/store_hash/v3/customers/1/metafields', [
  'body' => '{
  "permission_set": "app_only",
  "namespace": "Sales Department",
  "key": "Staff Name",
  "value": "Ronaldo"
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'X-Auth-Token' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.bigcommerce.com/stores/store_hash/v3/customers/1/metafields");
var request = new RestRequest(Method.POST);
request.AddHeader("X-Auth-Token", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"permission_set\": \"app_only\",\n  \"namespace\": \"Sales Department\",\n  \"key\": \"Staff Name\",\n  \"value\": \"Ronaldo\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "X-Auth-Token": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "permission_set": "app_only",
  "namespace": "Sales Department",
  "key": "Staff Name",
  "value": "Ronaldo"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.bigcommerce.com/stores/store_hash/v3/customers/1/metafields")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```